version: 2

models:
  - name: sfdc_accounts_xf
    columns:
      - name: account_id
        tests:
          - not_null
      - name: account_name
        tests:
          - not_null
  - name: sfdc_account_deal_size_segmentation
    columns:
      - name: account_id
        tests:
          - not_null
          - unique
      - name: close_date
        tests:
          - not_null
      - name: deal_size
        tests:
          - not_null
  - name: sfdc_bizible_attribution_touchpoint_xf
    columns:
      - name: touchpoint_id
        tests:
          - not_null
          - unique
  - name: sfdc_campaign_xf
    columns:
      - name: campaign_id
        tests:
          - not_null
          - unique
  - name: sfdc_closed_deals_acv
    columns:
      - name: opportunity_owner
        tests:
          - not_null
  - name: sfdc_competitors_to_be_replaced
    columns:
      - name: opportunity_id
        tests:
          - not_null
  - name: sfdc_contact_xf
    columns:
      - name: contact_id
        tests:
          - not_null
          - unique
  - name: sfdc_executive_business_review_xf
    columns:
      - name: owner_id
        tests:
          - not_null
  - name: sfdc_lead_source
    columns:
      - name: lead_source_id
        tests:
          - not_null
          - unique
      - name: initial_source
        tests:
          - not_null
      - name: initial_source_type
        tests:
          - not_null
  - name: sfdc_lead_xf
    columns:
      - name: lead_id
        tests:
          - not_null
          - unique
  - name: sfdc_opportunity_field_historical 
    description: '{{ doc("sfdc_opportunity_field_historical") }}' 
    columns:
      - name: opportunity_id
        tests:
          - not_null
      - name: valid_from
        tests:
          - not_null             
  - name: sfdc_opportunity_snapshot_history
    description: This model constrains the scope of sfdc_opportunity_snapshots_base to the columns in sfdc_opportunity_xf and their corresponding aliases.
    columns:
        - name: account_id
          tests:
            - not_null
        - name: opportunity_id
          tests:
            - not_null
        - name: opportunity_name
          tests:
            - not_null
        - name: stage_name
          tests:
            - not_null
        - name: valid_from
          tests: 
            - not_null      
  - name: sfdc_opportunity_stage_duration
    description: '{{ doc("sfdc_opportunity_stage_duration") }}'
    columns:
      - name: primary_key
        tests:
          - not_null                        
  - name: sfdc_opportunity_xf
    columns:
      - name: opportunity_id
        tests:
          - not_null
          - unique
      - name: owner_id
        description: The SFDC ID of opportunity owner.
        tests:
            - not_null
      - name: sales_segment
        tests:
          - accepted_values:
              values: ['SMB', 'Mid-Market', 'Strategic', 'Large', 'Unknown']
      - name: parent_segment
        tests:
          - accepted_values:
              values: ['SMB', 'Mid-Market', 'Strategic', 'Large', 'Unknown', Null]
  - name: sfdc_pipeline
    columns:
      - name: opportunity_owner
        tests:
          - not_null
  - name: sfdc_proof_of_concept_xf
    columns:
      - name: poc_id
        tests:
          - not_null
          - unique
      - name: account_id
        tests:
          - not_null
          - relationships:
              to: ref('sfdc_account')
              field: account_id
      - name: opportunity_id
        tests:
          - not_null
          - relationships:
              to: ref('sfdc_opportunity_xf')
              field: opportunity_id
      - name: poc_status
        tests:
          - not_null
  - name: sfdc_reason_for_loss_unpacked
    columns:
      - name: opportunity_id
        tests:
          - not_null
  - name: sfdc_sales_accepted_opportunity
    columns:
      - name: opportunity_name
        tests:
          - not_null
      - name: account_name
        tests:
          - not_null
  - name: sfdc_statement_of_work_xf
    columns:
      - name: statement_of_work_id
        tests:
          - not_null
          - unique
  - name: sfdc_users_xf
    columns:
      - name: id
        tests:
          - not_null
          - unique     